<!-- Copyright 2022 The LumoSQL Authors, see LICENSES/MIT -->

<!-- SPDX-License-Identifier: CC-BY-SA-4.0 -->
<!-- SPDX-FileCopyrightText: 2022 The LumoSQL Authors -->
<!-- SPDX-ArtifactOfProjectName: LumoSQL -->
<!-- SPDX-FileType: Documentation -->
<!-- SPDX-FileComment: Original by Dan Shearer, December 2019 -->

# LumoSQL Code of Conduct

Version 1.5 – Updated 18th February, 2022

**This file exists because the LumoSQL Project needed it, less than one year
after starting in 2019. We take it seriously. We take the view that this file is
about mandating kindness. We are in a global pandemic when kindness is needed more
than ever.**

The LumoSQL Project welcomes contributions from anyone who shares
[the LumoSQL Project Goals](https://lumosql.org/src/lumodoc/doc/trunk/doc/lumo-project-aims.md)
This document outlines both expected and prohibited behaviour.

# Short Summary

The rest of this document is detail to support these three points:

* LumoSQL participants are to be respectful and direct with each other.
* We will not tolerate bullying, racism, sexism or constant domineering behaviour.
* No personal attacks, and generally stay focussed on what we are trying to achieve. 

# Who Should Feel Safe?

Everyone, regardless of diversity dimensions including:

* Gender, identity or expression
* Age
* Socioeconomic status
* Sex or sexual orientation
* Family status
* Race and/or caste and/or ethnicity
* National origin
* Religion
* Native or other languages

# When Should They Feel Safe?

* Working with other LumoSQL community participants virtually or co-located
* Representing LumoSQL at public events
* Representing LumoSQL in social media

# What is Expected?

The following behaviours are expected of all LumoSQL community participants:

## Be Respectful

Value each other’s ideas, styles and viewpoints. Disagreement is no excuse for
bad manners. Be open to different possibilities and to being wrong. Take
responsibility, so if someone says they have been harmed through your words or
actions, listen carefully, apologise sincerely, and correct the behaviour.

## Be Direct but Professional

We must be able to speak directly when we disagree and when we think we need to
improve. We cannot withhold hard truths.  Doing so respectfully is hard, doing
so when others don’t seem to be listening is harder, and hearing such comments
when can be harder still.

## Be Inclusive

Seek diverse perspectives. Diversity of views and of people gives better
results.  Encourage all voices. Help new perspectives be heard and listen
actively. If you find yourself dominating a discussion, step back and give
other people a chance.  Observe how much time is taken up by dominant members
of the group.

## Appreciate and Accommodate Our Similarities and Differences

Be respectful of people with different cultural practices, attitudes and
beliefs. Work to eliminate your own biases, prejudices and discriminatory
practices. Think of others’ needs from their point of view. Use preferred
titles (including pronouns). Respect people’s right to privacy and
confidentiality. Be open to learning from and educating others as well as
educating yourself.

# Behaviour That Will Not Be Tolerated

The following behaviours are unacceptable, as should be obvious in any case:

## Violence and Threats of Violence Are Not Acceptable

Offline or online, including incitement of violence or encouraging a person to
commit self-harm. This also includes posting or threatening to post other
people’s personal data (“doxxing”) online.

## Derogatory Language Is Not Acceptable

Hurtful or harmful language related to any dimension of diversity is not
acceptable.

This includes deliberately referring to someone by a gender that they do not
identify with, or questioning an individual’s gender identity. If you’re unsure
if a word is derogatory, don’t use it.  When asked to stop, stop the behaviour.

## Unwelcome Sexual Attention or Physical Contact Is Not Acceptable

This section is here because it has been proven to be needed where LumoSQL has
been present. It is not some formality.  If you don't think it is needed, you have
not been paying attention.

Unwelcome sexual attention online or offline, or unwelcome physical contact is
not acceptable. This includes sexualised comments, jokes or imagery as well as
inappropriate touching, groping, or sexual advances.  This also includes
physically blocking or intimidating another person. Physical contact or
simulated physical contact (potentially including emojis) without affirmative
consent is not acceptable.

# Consequences of Unacceptable Behaviour

Bad behaviour from any LumoSQL community participant can't be tolerated.
Intentional efforts to exclude people (except as part of a consequence of these
guidelines) from LumoSQL activities are not acceptable.

Reports of harassment/discrimination will be promptly and thoroughly
investigated by the people responsible for the safety of the space, event or
activity, with a view to taking action.

Anyone asked to stop unacceptable behaviour is expected to stop immediately.
Violation of these guidelines can result in you being ask to leave an event or
online space, either temporarily or for the duration of the event, or being
banned from participation in spaces, or future events and activities.

Participants who abuse the reporting process will be considered to be in
violation. False reporting, especially to retaliate or exclude, will not be
accepted or tolerated.

# Reporting

If you believe you’re experiencing unacceptable behaviour 
as outlined above please contact one of the 
[current authors](https://lumosql.org/src/lumosql/file?name=AUTHORS).

After receiving a concise description of your situation, they will review and
determine next steps. 

Please also report to us if you observe someone else in distress or violations of
these guidelines.

If you feel you have been unfairly accused of violating these guidelines,
please follow the same reporting process.

<hr>

This document is (c) 2022 The LumoSQL Authors, under the [Creative Commons Attribution-ShareAlike 4.0 International](https://creativecommons.org/licenses/by-sa/4.0/) license.

*Heavily Adapted and Compressed from the surprisingly large version 3.1 of the 
[Mozilla Participation Guidelines](https://www.mozilla.org/en-US/about/governance/policies/participation/)
which Mozilla released under the Creative Commons Attribution-ShareAlike 4.0 International. We thank Mozilla for their work.*

